﻿function onCalendarShownMonths(cal) {
    cal._switchMode("months", true);

    if (cal._monthsBody) {
        for (var i = 0; i < cal._monthsBody.rows.length; i++) {
            var row = cal._monthsBody.rows[i];
            for (var j = 0; j < row.cells.length; j++) {
                $addHandler(row.cells[j].firstChild, 'click', function (e) {

                    e.stopPropagation();
                    e.preventDefault();

                    if (!cal._enabled) return;

                    var target = e.target;
                    var visibleDate = cal._getEffectiveVisibleDate();
                    Sys.UI.DomElement.removeCssClass(target.parentNode, "ajax__calendar_hover");

                    switch (target.mode) {
                        case "month":
                            if (target.month != visibleDate.getMonth()) {
                                cal._visibleDate = target.date;
                            }
                            cal.set_selectedDate(target.date);
                            cal._switchMonth(target.date);
                            cal._blur.post(true);
                            cal.raiseDateSelectionChanged();
                            break;
                    }
                },
                true);
            }
        }
    }
}

function onCalendarShownYears(cal) {
    cal._switchMode("years", true);

    if (cal._yearsBody) {
        for (var i = 0; i < cal._yearsBody.rows.length; i++) {
            var row = cal._yearsBody.rows[i];
            for (var j = 0; j < row.cells.length; j++) {
                $addHandler(row.cells[j].firstChild, 'click', function (e) {

                    e.stopPropagation();
                    e.preventDefault();

                    if (!cal._enabled) return;

                    var target = e.target;
                    var visibleDate = cal._getEffectiveVisibleDate();
                    Sys.UI.DomElement.removeCssClass(target.parentNode, "ajax__calendar_hover");

                    switch (target.mode) {
                        case "year":
                            if (target.date.getFullYear() != visibleDate.getFullYear()) {
                                cal._visibleDate = target.date;
                            }
                            cal.set_selectedDate(target.date);
                            cal._switchMonth(target.date);
                            cal._blur.post(true);
                            cal.raiseDateSelectionChanged();
                            break;
                    }
                },
                true);
            }
        }
    }
}

function onCalendarHidden(cal) {
    if (cal.get_selectedDate()) {
        var finalDate = new Date(cal.get_selectedDate());
        finalDate.setDate(1);
    }
}